#!/usr/bin/perl
# $Id: fill_services_cfg.cgi,v 1.0.9.2 1998/06/02 18:00:41 jens Exp $
# $Date: 1998/06/02 18:00:41 $
#
# File: fill_services_cfg.cgi
# Desc: fill the configuration form
#       with the current definitions
#
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2, or (at your option)
#   any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
# (c) Copyright 1998 J. Hellmerichs-Friedrich
#
# $Log: fill_services_cfg.cgi,v $
# Revision 1.0.9.2  1998/06/02 18:00:41  jens
# *** empty log message ***
#
# Revision 1.0.9.1  1998/06/01 19:34:37  jens
# initial ci -r 1.0.9
#
# Revision 1.0  1998/06/01 19:32:21  jens
# initial ci -r 1.0
#
#
 
$fwdir=`pwd`;
$fwdir =~ s/\/cgi-bin//;
chomp ($fwdir);

$cfg_dir = "$fwdir/etc/config";

sub print_file {
  foreach $file (@_) {
    open (FILE, "$file");
    while (<FILE>) {
      print ;
    }
  }
}

sub list_services {
  $cnt=0;
  foreach $serv ( @_ ) {
    chomp(($service, $def) = split (/=/, $serv));
    next unless ( -r "$cfg_dir/$service.def" );
    
    if ( ++$cnt == 2 ) {
      $trb=''; $tre='</tr>'; $cnt=0;
    } else {
      $trb='<tr>'; $tre='';
    }
    $sel_b='';$sel_f='';$sel_i='';$sel_o='';

    if ( $def =~ /'OUT'/ ) {
      $sel_o="selected";
    } elsif ( $def =~ /'FILTERED'/ ) {
      $sel_f="selected";
    } elsif ( $def =~ /'IN'/ ) {
      $sel_i="selected";
    } else {
      $sel_b="selected";
    }

    print "$trb\n";
    print "    <td align=\"right\"> $service</td>\n";
    print "    <td><select name=\"$service\" size=\"1\">\n";
    print "        <option $sel_b value=\"BLOCKED\">Blocked</option>\n";
    print "        <option $sel_f value=\"FILTERED\">Filtered</option>\n";
    print "        <option $sel_i value=\"IN\">Incoming</option>\n";
    print "        <option $sel_o value=\"OUT\">Outgoing</option>\n";
    print "        </select></td>\n";

    print "$tre\n";
  }
}

# read the selected service-configuration
# from etc/services.cfg
# -> @services_cfg

open SERVICE_CFG, "$fwdir/etc/services.cfg";
do {
    chomp ( $line = <SERVICE_CFG> );
} while ( grep !/^# THE LINES BELOW ARE AUTOMATICALLY GENERATED/, $line );
while ( <SERVICE_CFG> ) {
  if ( grep /^\w+=.*$/, $_ ) {
    push @services, $_;
    push @selected, $_;
  }
}

#
# print the results (html)
#
print "Content-type: text/html\n\n";

print_file ($fwdir . "/etc/sheets/services_cfg_head.htm");
print_file ($fwdir . "/etc/sheets/services_cfg_body.htm");
list_services (sort @services);

  opendir CFG_DIR, $cfg_dir;
  @files = grep /^[a-zA-Z]\w*\.def/, readdir CFG_DIR;
  closedir CFG_DIR;
  foreach $file (sort @files) {
    ($serv, $suffix) = split /\./, $file;
    unless ( grep /^$serv=/, @services ) {
      @file_svc = (@file_svc, $serv);
    }
  }
list_services (sort @file_svc);

print_file ($fwdir . "/etc/sheets/services_cfg_end.htm");

close SERVICE_CFG;
